<template>
  <div>
    <v-container
      fill-height
      fluid
      grid-list-xl
    >
      <v-layout
        justify-center
        wrap
      >
        <v-flex
          md10
        >
          <div>
            <material-card
              :title="currentStudent.code+' '+ currentStudent.firstName+' '+ currentStudent.lastName"
              color="green"
            >
              <template>
                <v-data-table
                  :headers="headers"
                  :items="course"
                  :custom-sort="customSort"
                  hide-actions
                >
                  <template
                    slot="items"
                    slot-scope="props">
                    <td>{{ props.item.academic_year }}</td>
                    <td>{{ props.item.code }}</td>
                    <td>{{ props.item.name }}</td>
                    <td>{{ props.item.credit }}</td>
                    <td>{{ props.item.grade }}</td>
                  </template>
                </v-data-table>
              </template>
            </material-card>
          </div>
        </v-flex>
      </v-layout>
    </v-container>
    <v-container>
      <v-card
        class="mx-auto py-3"
        color="success"
        dark
        max-width="300"
      >
        <v-card-text class="text-xs-center headline font-weight-bold">
          GPA : {{ currentStudent.gpax }}
        </v-card-text>
      </v-card>
    </v-container>
  </div>
</template>

<script>
import { mapState, mapGetters } from 'vuex'

export default {
  data () {
    return {
      loading: false,
      headers: [
        {
          text: 'Academic Year',
          value: 'academic_year'
        },
        {
          text: 'Subject Code',
          value: 'code'
        },
        {
          text: 'Subject name',
          value: 'name'
        },
        {
          text: 'Credit',
          value: 'credit'
        },
        {
          text: 'Grade',
          value: 'grade'
        }
      ],
      studentCode: localStorage.getItem('studentCode')
    }
  },
  computed: {
    ...mapGetters('web3', ['contract', 'currentStudent', 'course']),
    ...mapState('app', ['image', 'color'])
  },
  async created () {
    await this.$store.dispatch('web3/connectToWeb3')
    await this.$store.dispatch('web3/setContract')
    await this.$store.dispatch('web3/fetchStudentCourse', this.studentCode)
  },
  methods: {
    customSort (items, index, isDesc) {
      items.sort((a, b) => {
        if (index === 'academic_year') {
          const aSemeter = a.academic_year.split('/')[0]
          const aYear = a.academic_year.split('/')[1]
          const bSemeter = b.academic_year.split('/')[0]
          const bYear = b.academic_year.split('/')[1]
          if (!isDesc) {
            if (aYear === bYear) {
              if (aSemeter < bSemeter) {
                return -1
              } else {
                return 1
              }
            } else if (aYear < bYear) {
              return -1
            } else {
              return 1
            }
          } else {
            if (bYear === aYear) {
              if (bSemeter < aSemeter) {
                return -1
              } else {
                return 1
              }
            } else if (bYear < aYear) {
              return -1
            } else {
              return 1
            }
          }
        } else {
          if (!isDesc) {
            return a[index] < b[index] ? -1 : 1
          } else {
            return b[index] < a[index] ? -1 : 1
          }
        }
      })
      return items
    }
  }
}
</script>

<style scoped>

</style>
